"""
    ASCII - Used in special keys translation
"""
__updated__ = "2022-10-07 12:23:54"

SPECIAL_KEYS_DICT = {       # Dec	Hex	    Hex	    Oct	    Oct	    Binary	Escaped	Ctrl Code	Character	Name
    # "\x00": "[Ctrl+A]",   # 0	    \x00	(0x00)	\0	    (00)	0	    \0	    ^@		                Null char
    "\x01": "[Ctrl+A]",     # 1	    \x01	(0x01)	\1	    (01)	1	 	        ^A	                    Start of Heading
    "\x02": "[Ctrl+B]",     # 2	    \x02	(0x02)	\2	    (02)	10	 	        ^B	                    Start of Text
    "\x03": "[Ctrl+C]",     # 3	    \x03	(0x03)	\3	    (03)	11	 	        ^C                      End of Text
    "\x04": "[Ctrl+D]",     # 4	    \x04	(0x04)	\4	    (04)	100	 	        ^D	             	    End of Transmission
    "\x05": "[Ctrl+E]",     # 5	    \x05	(0x05)	\5	    (05)	101	 	        ^E	             	    Enquiry
    "\x06": "[Ctrl+F]",     # 6	    \x06	(0x06)	\6	    (06)	110	 	        ^F	             	    Acknowledgment
    "\x07": "[Ctrl+G]",     # 7	    \x07	(0x07)	\7	    (07)	111	    \a	    ^G	             	    Bell
    "\x08": "[Ctrl+H]",     # 8	    \x08	(0x08)	\10	    (010)	1000	\b	    ^H	             	    Back Space
    # "\t": "[Tab]",        # 9	    \x09	(0x09)	\11	    (011)	1001	\t	    ^I	            TAB	    Horizontal Tab
    # "\n": "[LF]",         # 10	\x0A	(0x0A)	\12	    (012)	1010	\n	    ^J	            LF	    Line Feed
    "\x0b": "[Ctrl+K]",     # 11	\x0B	(0x0B)	\13	    (013)	1011	\v	    ^K	             	    Vertical Tab
    "\x0c": "[Ctrl+L]",     # 12	\x0C	(0x0C)	\14	    (014)	1100	\f	    ^L	             	    Form Feed
    # "\r": "[Enter]\r\n",  # 13	\x0D	(0x0D)	\15	    (015)	1101	\r	    ^M	            CR	    Carriage Return
    "\x0e": "[Ctrl+N]",     # 14	\x0E	(0x0E)	\16	    (016)	1110	 	    ^N	             	    Shift Out / X-On
    "\x0f": "[Ctrl+O]",     # 15	\x0F	(0x0F)	\17	    (017)	1111	 	    ^O	             	    Shift In / X-Off
    "\x10": "[Ctrl+P]",     # 16	\x10	(0x10)	\20	    (020)	10000	 	    ^P	             	    Data Line Escape
    "\x11": "[Ctrl+Q]",     # 17	\x11	(0x11)	\21	    (021)	10001	 	    ^Q	             	    Device Control 1 (oft. XON)
    "\x12": "[Ctrl+R]",     # 18	\x12	(0x12)	\22	    (022)	10010	 	    ^R	             	    Device Control 2
    "\x13": "[Ctrl+S]",     # 19	\x13	(0x13)	\23	    (023)	10011	 	    ^S	             	    Device Control 3 (oft. XOFF)
    "\x14": "[Ctrl+T]",     # 20	\x14	(0x14)	\24	    (024)	10100	 	    ^T	             	    Device Control 4
    "\x15": "[Ctrl+U]",     # 21	\x15	(0x15)	\25	    (025)	10101	 	    ^U	             	    Negative Acknowledgement
    "\x16": "[Ctrl+V]",     # 22	\x16	(0x16)	\26	    (026)	10110	 	    ^V	             	    Synchronous Idle
    "\x17": "[Ctrl+W]",     # 23	\x17	(0x17)	\27	    (027)	10111	 	    ^W	             	    End of Transmit Block
    "\x18": "[Ctrl+X]",     # 24	\x18	(0x18)	\30	    (030)	11000	 	    ^X	             	    Cancel
    "\x19": "[Ctrl+Y]",     # 25	\x19	(0x19)	\31	    (031)	11001	 	    ^Y	             	    End of Medium
    "\x1a": "[Ctrl+Z]",     # 26	\x1A	(0x1A)	\32	    (032)	11010	 	    ^Z	             	    Substitute
    "\x1b": "[Ctrl+[]",     # 27	\x1B	(0x1B)	\33	    (033)	11011	 	    ^[	             	    Escape
    "\x1d": "[Ctrl+]]",     # 29	\x1D	(0x1D)	\35	    (035)	11101	 	    ^]	             	    Group Separator
    # "\x1e": "[^^]",       # 30	\x1E	(0x1E)	\36	    (036)	11110	 	    ^^	             	    Record Separator
    "\x1f": "[Ctrl+/]",     # 31	\x1F	(0x1F)	\37	    (037)	11111	 	    ^_	                	Unit Separator
    # "\x20": "[SPACE]",    # 32	\x20	(0x20)	\40	    (040)	100000	 	 	  	            SPACE
    "\x7f": "[<--]"         # 127	\x7F	(0x7F)	\177	(0177)	1111111	 	 	
}

# 33	\x21	(0x21)	\41	    (041)	100001	 	 	!
# 34	\x22	(0x22)	\42	    (042)	100010	\"	 	"
# 35	\x23	(0x23)	\43	    (043)	100011	 	 	#
# 36	\x24	(0x24)	\44	    (044)	100100	 	 	$
# 37	\x25	(0x25)	\45	    (045)	100101	 	 	%
# 38	\x26	(0x26)	\46	    (046)	100110	 	 	&
# 39	\x27	(0x27)	\47	    (047)	100111	\'	 	'
# 40	\x28	(0x28)	\50	    (050)	101000	 	 	(
# 41	\x29	(0x29)	\51	    (051)	101001	 	 	)
# 42	\x2A	(0x2A)	\52	    (052)	101010	 	 	*
# 43	\x2B	(0x2B)	\53	    (053)	101011	 	 	+
# 44	\x2C	(0x2C)	\54	    (054)	101100	 	 	,
# 45	\x2D	(0x2D)	\55	    (055)	101101	 	 	-
# 46	\x2E	(0x2E)	\56	    (056)	101110	 	 	.
# 47	\x2F	(0x2F)	\57	    (057)	101111	 	 	/
# 48	\x30	(0x30)	\60	    (060)	110000	 	 	0
# 49	\x31	(0x31)	\61	    (061)	110001	 	 	1
# 50	\x32	(0x32)	\62	    (062)	110010	 	 	2
# 51	\x33	(0x33)	\63	    (063)	110011	 	 	3
# 52	\x34	(0x34)	\64	    (064)	110100	 	 	4
# 53	\x35	(0x35)	\65	    (065)	110101	 	 	5
# 54	\x36	(0x36)	\66	    (066)	110110	 	 	6
# 55	\x37	(0x37)	\67	    (067)	110111	 	 	7
# 56	\x38	(0x38)	\70	    (070)	111000	 	 	8
# 57	\x39	(0x39)	\71	    (071)	111001	 	 	9
# 58	\x3A	(0x3A)	\72	    (072)	111010	 	 	:
# 59	\x3B	(0x3B)	\73	    (073)	111011	 	 	;
# 60	\x3C	(0x3C)	\74	    (074)	111100	 	 	<
# 61	\x3D	(0x3D)	\75	    (075)	111101	 	 	=
# 62	\x3E	(0x3E)	\76	    (076)	111110	 	 	>
# 63	\x3F	(0x3F)	\77	    (077)	111111	 	 	?
# 64	\x40	(0x40)	\100	(0100)	1000000	 	 	@
# 65	\x41	(0x41)	\101	(0101)	1000001	 	 	A
# 66	\x42	(0x42)	\102	(0102)	1000010	 	 	B
# 67	\x43	(0x43)	\103	(0103)	1000011	 	 	C
# 68	\x44	(0x44)	\104	(0104)	1000100	 	 	D
# 69	\x45	(0x45)	\105	(0105)	1000101	 	 	E
# 70	\x46	(0x46)	\106	(0106)	1000110	 	 	F
# 71	\x47	(0x47)	\107	(0107)	1000111	 	 	G
# 72	\x48	(0x48)	\110	(0110)	1001000	 	 	H
# 73	\x49	(0x49)	\111	(0111)	1001001	 	 	I
# 74	\x4A	(0x4A)	\112	(0112)	1001010	 	 	J
# 75	\x4B	(0x4B)	\113	(0113)	1001011	 	 	K
# 76	\x4C	(0x4C)	\114	(0114)	1001100	 	 	L
# 77	\x4D	(0x4D)	\115	(0115)	1001101	 	 	M
# 78	\x4E	(0x4E)	\116	(0116)	1001110	 	 	N
# 79	\x4F	(0x4F)	\117	(0117)	1001111	 	 	O
# 80	\x50	(0x50)	\120	(0120)	1010000	 	 	P
# 81	\x51	(0x51)	\121	(0121)	1010001	 	 	Q
# 82	\x52	(0x52)	\122	(0122)	1010010	 	 	R
# 83	\x53	(0x53)	\123	(0123)	1010011	 	 	S
# 84	\x54	(0x54)	\124	(0124)	1010100	 	 	T
# 85	\x55	(0x55)	\125	(0125)	1010101	 	 	U
# 86	\x56	(0x56)	\126	(0126)	1010110	 	 	V
# 87	\x57	(0x57)	\127	(0127)	1010111	 	 	W
# 88	\x58	(0x58)	\130	(0130)	1011000	 	 	X
# 89	\x59	(0x59)	\131	(0131)	1011001	 	 	Y
# 90	\x5A	(0x5A)	\132	(0132)	1011010	 	 	Z
# 91	\x5B	(0x5B)	\133	(0133)	1011011	 	 	[
# 92	\x5C	(0x5C)	\134	(0134)	1011100	\\	 	\
# 93	\x5D	(0x5D)	\135	(0135)	1011101	 	 	]
# 94	\x5E	(0x5E)	\136	(0136)	1011110	 	 	^
# 95	\x5F	(0x5F)	\137	(0137)	1011111	 	 	_
# 96	\x60	(0x60)	\140	(0140)	1100000	 	 	`
# 97	\x61	(0x61)	\141	(0141)	1100001	 	 	a
# 98	\x62	(0x62)	\142	(0142)	1100010	 	 	b
# 99	\x63	(0x63)	\143	(0143)	1100011	 	 	c
# 100	\x64	(0x64)	\144	(0144)	1100100	 	 	d
# 101	\x65	(0x65)	\145	(0145)	1100101	 	 	e
# 102	\x66	(0x66)	\146	(0146)	1100110	 	 	f
# 103	\x67	(0x67)	\147	(0147)	1100111	 	 	g
# 104	\x68	(0x68)	\150	(0150)	1101000	 	 	h
# 105	\x69	(0x69)	\151	(0151)	1101001	 	 	i
# 106	\x6A	(0x6A)	\152	(0152)	1101010	 	 	j
# 107	\x6B	(0x6B)	\153	(0153)	1101011	 	 	k
# 108	\x6C	(0x6C)	\154	(0154)	1101100	 	 	l
# 109	\x6D	(0x6D)	\155	(0155)	1101101	 	 	m
# 110	\x6E	(0x6E)	\156	(0156)	1101110	 	 	n
# 111	\x6F	(0x6F)	\157	(0157)	1101111	 	 	o
# 112	\x70	(0x70)	\160	(0160)	1110000	 	 	p
# 113	\x71	(0x71)	\161	(0161)	1110001	 	 	q
# 114	\x72	(0x72)	\162	(0162)	1110010	 	 	r
# 115	\x73	(0x73)	\163	(0163)	1110011	 	 	s
# 116	\x74	(0x74)	\164	(0164)	1110100	 	 	t
# 117	\x75	(0x75)	\165	(0165)	1110101	 	 	u
# 118	\x76	(0x76)	\166	(0166)	1110110	 	 	v
# 119	\x77	(0x77)	\167	(0167)	1110111	 	 	w
# 120	\x78	(0x78)	\170	(0170)	1111000	 	 	x
# 121	\x79	(0x79)	\171	(0171)	1111001	 	 	y
# 122	\x7A	(0x7A)	\172	(0172)	1111010	 	 	z
# 123	\x7B	(0x7B)	\173	(0173)	1111011	 	 	{
# 124	\x7C	(0x7C)	\174	(0174)	1111100	 	 	|
# 125	\x7D	(0x7D)	\175	(0175)	1111101	 	 	}
# 126	\x7E	(0x7E)	\176	(0176)	1111110	 	 	~
# 127	\x7F	(0x7F)	\177	(0177)	1111111	 	 	
# 128	\x80	(0x80)	\200	(0200)	10000000	 	�
# 129	\x81	(0x81)	\201	(0201)	10000001	 	�
# 130	\x82	(0x82)	\202	(0202)	10000010	 	�
# 131	\x83	(0x83)	\203	(0203)	10000011	 	�
# 132	\x84	(0x84)	\204	(0204)	10000100	 	�
# 133	\x85	(0x85)	\205	(0205)	10000101	 	�
# 134	\x86	(0x86)	\206	(0206)	10000110	 	�
# 135	\x87	(0x87)	\207	(0207)	10000111	 	�
# 136	\x88	(0x88)	\210	(0210)	10001000	 	�
# 137	\x89	(0x89)	\211	(0211)	10001001	 	�
# 138	\x8A	(0x8A)	\212	(0212)	10001010	 	�
# 139	\x8B	(0x8B)	\213	(0213)	10001011	 	�
# 140	\x8C	(0x8C)	\214	(0214)	10001100	 	�
# 141	\x8D	(0x8D)	\215	(0215)	10001101	 	�
# 142	\x8E	(0x8E)	\216	(0216)	10001110	 	�
# 143	\x8F	(0x8F)	\217	(0217)	10001111	 	�
# 144	\x90	(0x90)	\220	(0220)	10010000	 	�
# 145	\x91	(0x91)	\221	(0221)	10010001	 	�
# 146	\x92	(0x92)	\222	(0222)	10010010	 	�
# 147	\x93	(0x93)	\223	(0223)	10010011	 	�
# 148	\x94	(0x94)	\224	(0224)	10010100	 	�
# 149	\x95	(0x95)	\225	(0225)	10010101	 	�
# 150	\x96	(0x96)	\226	(0226)	10010110	 	�
# 151	\x97	(0x97)	\227	(0227)	10010111	 	�
# 152	\x98	(0x98)	\230	(0230)	10011000	 	�
# 153	\x99	(0x99)	\231	(0231)	10011001	 	�
# 154	\x9A	(0x9A)	\232	(0232)	10011010	 	�
# 155	\x9B	(0x9B)	\233	(0233)	10011011	 	�
# 156	\x9C	(0x9C)	\234	(0234)	10011100	 	�
# 157	\x9D	(0x9D)	\235	(0235)	10011101	 	�
# 158	\x9E	(0x9E)	\236	(0236)	10011110	 	�
# 159	\x9F	(0x9F)	\237	(0237)	10011111	 	�
# 160	\xA0	(0xA0)	\240	(0240)	10100000	 	�
# 161	\xA1	(0xA1)	\241	(0241)	10100001	 	�
# 162	\xA2	(0xA2)	\242	(0242)	10100010	 	�
# 163	\xA3	(0xA3)	\243	(0243)	10100011	 	�
# 164	\xA4	(0xA4)	\244	(0244)	10100100	 	�
# 165	\xA5	(0xA5)	\245	(0245)	10100101	 	�
# 166	\xA6	(0xA6)	\246	(0246)	10100110	 	�
# 167	\xA7	(0xA7)	\247	(0247)	10100111	 	�
# 168	\xA8	(0xA8)	\250	(0250)	10101000	 	�
# 169	\xA9	(0xA9)	\251	(0251)	10101001	 	�
# 170	\xAA	(0xAA)	\252	(0252)	10101010	 	�
# 171	\xAB	(0xAB)	\253	(0253)	10101011	 	�
# 172	\xAC	(0xAC)	\254	(0254)	10101100	 	�
# 173	\xAD	(0xAD)	\255	(0255)	10101101	 	�
# 174	\xAE	(0xAE)	\256	(0256)	10101110	 	�
# 175	\xAF	(0xAF)	\257	(0257)	10101111	 	�
# 176	\xB0	(0xB0)	\260	(0260)	10110000	 	�
# 177	\xB1	(0xB1)	\261	(0261)	10110001	 	�
# 178	\xB2	(0xB2)	\262	(0262)	10110010	 	�
# 179	\xB3	(0xB3)	\263	(0263)	10110011	 	�
# 180	\xB4	(0xB4)	\264	(0264)	10110100	 	�
# 181	\xB5	(0xB5)	\265	(0265)	10110101	 	�
# 182	\xB6	(0xB6)	\266	(0266)	10110110	 	�
# 183	\xB7	(0xB7)	\267	(0267)	10110111	 	�
# 184	\xB8	(0xB8)	\270	(0270)	10111000	 	�
# 185	\xB9	(0xB9)	\271	(0271)	10111001	 	�
# 186	\xBA	(0xBA)	\272	(0272)	10111010	 	�
# 187	\xBB	(0xBB)	\273	(0273)	10111011	 	�
# 188	\xBC	(0xBC)	\274	(0274)	10111100	 	�
# 189	\xBD	(0xBD)	\275	(0275)	10111101	 	�
# 190	\xBE	(0xBE)	\276	(0276)	10111110	 	�
# 191	\xBF	(0xBF)	\277	(0277)	10111111	 	�
# 192	\xC0	(0xC0)	\300	(0300)	11000000	 	�
# 193	\xC1	(0xC1)	\301	(0301)	11000001	 	�
# 194	\xC2	(0xC2)	\302	(0302)	11000010	 	�
# 195	\xC3	(0xC3)	\303	(0303)	11000011	 	�
# 196	\xC4	(0xC4)	\304	(0304)	11000100	 	�
# 197	\xC5	(0xC5)	\305	(0305)	11000101	 	�
# 198	\xC6	(0xC6)	\306	(0306)	11000110	 	�
# 199	\xC7	(0xC7)	\307	(0307)	11000111	 	�
# 200	\xC8	(0xC8)	\310	(0310)	11001000	 	�
# 201	\xC9	(0xC9)	\311	(0311)	11001001	 	�
# 202	\xCA	(0xCA)	\312	(0312)	11001010	 	�
# 203	\xCB	(0xCB)	\313	(0313)	11001011	 	�
# 204	\xCC	(0xCC)	\314	(0314)	11001100	 	�
# 205	\xCD	(0xCD)	\315	(0315)	11001101	 	�
# 206	\xCE	(0xCE)	\316	(0316)	11001110	 	�
# 207	\xCF	(0xCF)	\317	(0317)	11001111	 	�
# 208	\xD0	(0xD0)	\320	(0320)	11010000	 	�
# 209	\xD1	(0xD1)	\321	(0321)	11010001	 	�
# 210	\xD2	(0xD2)	\322	(0322)	11010010	 	�
# 211	\xD3	(0xD3)	\323	(0323)	11010011	 	�
# 212	\xD4	(0xD4)	\324	(0324)	11010100	 	�
# 213	\xD5	(0xD5)	\325	(0325)	11010101	 	�
# 214	\xD6	(0xD6)	\326	(0326)	11010110	 	�
# 215	\xD7	(0xD7)	\327	(0327)	11010111	 	�
# 216	\xD8	(0xD8)	\330	(0330)	11011000	 	�
# 217	\xD9	(0xD9)	\331	(0331)	11011001	 	�
# 218	\xDA	(0xDA)	\332	(0332)	11011010	 	�
# 219	\xDB	(0xDB)	\333	(0333)	11011011	 	�
# 220	\xDC	(0xDC)	\334	(0334)	11011100	 	�
# 221	\xDD	(0xDD)	\335	(0335)	11011101	 	�
# 222	\xDE	(0xDE)	\336	(0336)	11011110	 	�
# 223	\xDF	(0xDF)	\337	(0337)	11011111	 	�
# 224	\xE0	(0xE0)	\340	(0340)	11100000	 	�
# 225	\xE1	(0xE1)	\341	(0341)	11100001	 	�
# 226	\xE2	(0xE2)	\342	(0342)	11100010	 	�
# 227	\xE3	(0xE3)	\343	(0343)	11100011	 	�
# 228	\xE4	(0xE4)	\344	(0344)	11100100	 	�
# 229	\xE5	(0xE5)	\345	(0345)	11100101	 	�
# 230	\xE6	(0xE6)	\346	(0346)	11100110	 	�
# 231	\xE7	(0xE7)	\347	(0347)	11100111	 	�
# 232	\xE8	(0xE8)	\350	(0350)	11101000	 	�
# 233	\xE9	(0xE9)	\351	(0351)	11101001	 	�
# 234	\xEA	(0xEA)	\352	(0352)	11101010	 	�
# 235	\xEB	(0xEB)	\353	(0353)	11101011	 	�
# 236	\xEC	(0xEC)	\354	(0354)	11101100	 	�
# 237	\xED	(0xED)	\355	(0355)	11101101	 	�
# 238	\xEE	(0xEE)	\356	(0356)	11101110	 	�
# 239	\xEF	(0xEF)	\357	(0357)	11101111	 	�
# 240	\xF0	(0xF0)	\360	(0360)	11110000	 	�
# 241	\xF1	(0xF1)	\361	(0361)	11110001	 	�
# 242	\xF2	(0xF2)	\362	(0362)	11110010	 	�
# 243	\xF3	(0xF3)	\363	(0363)	11110011	 	�
# 244	\xF4	(0xF4)	\364	(0364)	11110100	 	�
# 245	\xF5	(0xF5)	\365	(0365)	11110101	 	�
# 246	\xF6	(0xF6)	\366	(0366)	11110110	 	�
# 247	\xF7	(0xF7)	\367	(0367)	11110111	 	�
# 248	\xF8	(0xF8)	\370	(0370)	11111000	 	�
# 249	\xF9	(0xF9)	\371	(0371)	11111001	 	�
# 250	\xFA	(0xFA)	\372	(0372)	11111010	 	�
# 251	\xFB	(0xFB)	\373	(0373)	11111011	 	�
# 252	\xFC	(0xFC)	\374	(0374)	11111100	 	�
# 253	\xFD	(0xFD)	\375	(0375)	11111101	 	�
# 254	\xFE	(0xFE)	\376	(0376)	11111110	 	�
# 255	\xFF	(0xFF)	\377	(0377)	11111111	 	�
